module counter(reset,clk,ir,t,pc);
input reset,clk;
input [7:0]ir;
input [1:0]t;
output [7:0]pc;
reg [7:0]p; //pc in counter

always@(posedge clk)
	begin
	if(!reset)
		begin
		p[0]=0;
		p[1]=0;
		p[2]=0;
		p[3]=0;
		p[4]=0;
		p[5]=0;
		p[6]=0;
		p[7]=0;
		end
	else if(t[1] && ir[7] && ir[6])
		begin
		p[0]=ir[0];
		p[1]=ir[1];
		p[2]=ir[2];
		p[3]=ir[3];
		p[4]=ir[4];
		p[5]=ir[5];
		p[6]=0;
		p[7]=0;
		end
	else if(t[0]) //counter++
		begin
		p[0]=~p[0];
		if(!p[0])
			begin
			p[1]=~p[1];
			if(!p[1])
				begin
				p[2]=~p[2];
				if(!p[2])
					begin
					p[3]=~p[3];
					if(!p[3])
						begin
						p[4]=~p[4];
						if(!p[4])
							begin
							p[5]=~p[5];
							if(!p[5])
								begin
								p[6]=~p[6];
								if(!p[6])
									p[7]=~p[7];
								end
							end
						end
					end
				end
			end
		end
	end

assign pc[0] = p[0];
assign pc[1] = p[1];
assign pc[2] = p[2];
assign pc[3] = p[3];
assign pc[4] = p[4];
assign pc[5] = p[5];
assign pc[6] = p[6];
assign pc[7] = p[7];

endmodule
